var gEFPFeedList = {
  VERSION: 1,
  FILE: "enhancedfeedpreview.js",

  getList: function EFPFL_getList() {
    var ds = Cc["@mozilla.org/file/directory_service;1"].
             getService(Ci.nsIProperties);
    var listFile = ds.get("ProfD", Ci.nsILocalFile);
    listFile.append(this.FILE);

    if (listFile.exists()) {
      var loader = Cc["@mozilla.org/moz/jssubscript-loader;1"].
                   getService(Ci.mozIJSSubScriptLoader);
      var ios = Cc["@mozilla.org/network/io-service;1"].
                getService(Ci.nsIIOService);
      var fph = ios.getProtocolHandler("file")
                   .QueryInterface(Ci.nsIFileProtocolHandler);
      var data = loader.loadSubScript(fph.getURLSpecFromFile(listFile));
      if (data && data.list)
        return data.list;
    }
    return [];
  },

  setList: function EFPFL_setList(aList) {
    var ds = Cc["@mozilla.org/file/directory_service;1"].
             getService(Ci.nsIProperties);
    var listFile = ds.get("ProfD", Ci.nsILocalFile);
    listFile.append(this.FILE);

    var stream = Cc["@mozilla.org/network/file-output-stream;1"].
                 createInstance(Ci.nsIFileOutputStream);
    stream.init(listFile, 0x02 | 0x08 | 0x20, 420, -1);

    var content = { version: this.VERSION, list: aList }.toSource();
    stream.write(content, content.length);
    stream.close();
  },

  addItem: function EFPFL_addItem(aItem) {
    var list = this.getList();
    var index = this.getInsertionIndex(list, aItem);
    if (index != -1) {
      list.splice(index, 0, aItem);
      this.setList(list);
    }
  },

  isInList: function EFPFL_isInList(aItem) {
    return this.getInsertionIndex(this.getList(), aItem) == -1;
  },

  getInsertionIndex: function EFPFL_getInsertionIndex(aList, aItem) {
    var left = 0, right = aList.length, mid;
    while (left < right) {
      mid = (left + right) >> 1; // Math.floor((left + right) / 2)
      if (aList[mid] > aItem)
        right = mid;
      else
        left = mid + 1;
    }
    // If the item is already in the list, return -1.
    return (left && aList[left - 1] == aItem) ? -1 : left;
  }
};
